Bug 119334 - Excessive recursion in SCSI layer when device offlined
Excessive recursion in SCSI layer when device offlined
Product: Red Hat Enterprise Linux 3
Classification: Red Hat
Component: kernel (Show other bugs)
All Linux
medium Severity high
: ---
: ---
Assigned To: Doug Ledford
Brian Brock
Depends On:
  Show dependency treegraph
Reported: 2004-03-29 12:09 EST by Justin T. Gibbs
Modified: 2007-11-30 17:07 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2004-03-31 10:48:12 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
2.4.X kernel.org patch that fixes this issue (1.55 KB, patch)
2004-03-29 12:10 EST, Justin T. Gibbs
no flags Details | Diff

  None (edit)
Description Justin T. Gibbs 2004-03-29 12:09:05 EST
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; FreeBSD i386; en-US; rv:1.3.1)

Description of problem:

The SCSI mid-layer blows out the kernel stack due to the
inherent recursion in its request function.  The repeating
stack trace goes something like:


Version-Release number of selected component (if applicable):

How reproducible:

Steps to Reproduce:
1. Queue up lots of I/O to a device.
2. Set that device offline.  (Pull a drive, etc.)

Actual Results:  System crashes

Expected Results:  System should recover from the failure.  In our
particular case,
we were testing (E)MD failure recovery.

Additional info:
Comment 1 Justin T. Gibbs 2004-03-29 12:10:50 EST
Created attachment 98938 [details]
2.4.X kernel.org patch that fixes this issue

Here is a fix I proposed on linux-scsi.  It applies to RHEL3 with only
one, easily resolved, reject.
Comment 2 Justin T. Gibbs 2004-03-29 12:38:07 EST
Seems "upstream" 2.4.X already handles this issue by using
__scsi_release_command inside __scsi_end_request to avoid
the recursion.
Comment 3 Doug Ledford 2004-03-30 15:52:20 EST
What kernel version are you testing against.  This should be fixed
already.  In the tree I'm looking at, __scsi_release_command already
uses __scsi_end_request.
Comment 4 Justin T. Gibbs 2004-03-30 16:39:41 EST
I was looking at 2.4.21-EL.4.  Looking at the QU2 beta, it appears
fixed there.
Comment 5 Doug Ledford 2004-03-31 10:48:12 EST
That's what I thought.  Closing bug as ERRATA.
Comment 6 Ernie Petrides 2005-10-05 23:13:31 EDT
This problem was fixed in RHEL3 U1.

Note You need to log in before you can comment on or make changes to this bug.